export interface SubscriptionDefinition {
    channel: string | null;
    message: string;
}
export interface Subscription {
    id: string;
    channelName: string;
    messageName: string;
}
export interface Channel {
    messages: Map<string, MessageListener>;
}
export interface PublishDefinition {
    channel: string;
    message: string;
}
export interface Payload {
}
export interface Message {
    id: MessageID;
    payload: any;
}
export interface Listener {
    id: string;
    messageID: MessageID;
    handler: (message: Message) => void;
    errorHandler?: (error: any) => void;
}
export interface MessageListener {
    listeners: Array<Listener>;
}
export type MessageID = string;
export declare class PubSubProxy {
    subscriptions: Array<string>;
    pubsub: PubSub;
    constructor(pubsub: PubSub);
    on(messageID: string, handler: (payload: any) => void): void;
    send<T>(messageID: string, payload: any): void;
    off(): void;
}
export default class PubSub {
    sendQueue: Array<Message>;
    messageListeners: Map<MessageID, MessageListener>;
    allListeners: Map<string, Listener>;
    sendPending: boolean;
    constructor();
    private sendMessages;
    private activateSend;
    send<T>(messageID: string, payload: any): void;
    on(messageID: string, handler: (m: Message) => void, errorHandler?: (e: any) => void): string;
    off(id: string): void;
}
