import { JSONArray } from '../../json';
import { ServiceClient, ServiceClientParams } from './ServiceClient';
export interface DynamicServiceClientParams extends ServiceClientParams {
    version?: string;
}
export declare abstract class DynamicServiceClient extends ServiceClient {
    version: string | null;
    abstract module: string;
    serviceDiscoveryURL: string;
    serviceDiscoveryModule: string;
    constructor(params: DynamicServiceClientParams);
    private moduleId;
    private getCached;
    private lookupModule;
    callFunc<ParamType extends JSONArray, ReturnType extends JSONArray>(funcName: string, params: ParamType): Promise<ReturnType>;
    callFuncEmptyResult<ParamType extends JSONArray>(funcName: string, params: ParamType): Promise<void>;
}
