import { JSONValue } from '../../json';
import { JSONRPCParams } from './JSONRPC20';
export interface ServiceClientParams {
    url: string;
    timeout: number;
    token?: string;
    prefix?: boolean;
}
export declare abstract class ServiceClient {
    abstract module: string;
    url: string;
    timeout: number;
    token?: string;
    prefix?: boolean;
    protected constructor({ url, timeout, token, prefix, }: ServiceClientParams);
    callFunc(funcName: string, params?: JSONRPCParams): Promise<JSONValue>;
}
