export type JSONScalarValue = string | number | boolean | null;
export type JSONValue = JSONScalarValue | JSONObject | JSONArray;
export interface JSONObjectOf<T extends JSONValue> {
    [x: string]: T;
}
export type JSONObject = JSONObjectOf<JSONValue>;
export interface JSONArrayOf<T extends JSONValue> extends Array<T> {
}
export type JSONArray = JSONArrayOf<JSONValue>;
export declare function isJSONObject(value: any): value is JSONObject;
export declare function isJSONArray(value: any): value is JSONArray;
export declare function isJSONValue(value: any): value is JSONValue;
export declare function objectToJSONObject(obj: {}): JSONObject;
export declare function normalizePropPath(propPath: PropsPath): Array<string>;
export type PropsPath = string | Array<string>;
export declare function traverse(obj: JSONObject, path: PropsPath, defaultValue?: JSONValue): JSONValue;
