"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toJSON = exports.toJSONLike = void 0;
function toJSONLike(like) {
    switch (typeof like) {
        case 'string':
        case 'number':
        case 'boolean':
            return like;
        case 'undefined':
            return like;
        case 'object':
            if (like === null) {
                return like;
            }
            else if (Array.isArray(like)) {
                const na = [];
                for (const item of like) {
                    na.push(toJSONLike(item));
                }
                return na;
            }
            else if (like.constructor !== {}.constructor) {
                const x = {};
                for (const [k, v] of Object.entries(like)) {
                    x[k] = toJSONLike(v);
                }
                return x;
            }
            else {
                throw new Error(`Not acceptable JSONLikeObject value: ${typeof like}`);
            }
        default:
            throw new Error(`Not acceptable JSONLike value: ${typeof like}`);
    }
}
exports.toJSONLike = toJSONLike;
function toJSON(like) {
    switch (typeof like) {
        case 'string':
        case 'number':
        case 'boolean':
            return like;
        case 'undefined':
            throw new Error('Should never see this!');
        case 'object':
            if (like === null) {
                return like;
            }
            else if (Array.isArray(like)) {
                const na = [];
                for (const item of like) {
                    if (typeof item !== 'undefined') {
                        na.push(toJSON(item));
                    }
                }
                return na;
            }
            else {
                const x = {};
                for (const [k, v] of Object.entries(like)) {
                    if (typeof v !== 'undefined') {
                        x[k] = toJSON(v);
                    }
                }
                return x;
            }
        default:
            throw new Error(`Not acceptable JSON value: ${typeof like}`);
    }
}
exports.toJSON = toJSON;
//# sourceMappingURL=jsonLike.js.map